local E, L, V, P, G = unpack(ElvUI);
local mPlugin = "mMediaTag"
local mMT = E:GetModule(mPlugin);
local DT = E:GetModule("DataTexts");
local addon, ns = ...

--Lua functions
local mInsert = table.insert

local function OptionsSystemMenu()
	E.Options.args.mMediaTag.args.datatext.args.systemmenusettings.args = {
		headersystemmenu = {
			order = 1,
			type = "header",
			name = L["General"],
		},
		systemmmenucolor = {
			order = 3,
			type = 'toggle',
			name = L["Colored System Menu"],
			desc = L["Activates a colored system menu."],
			get = function(info)
				return E.db[mPlugin].mMenuColor
			end,
			set = function(info, value)
				E.db[mPlugin].mMenuColor = value
			end,
		},
		systemmmenushowicon = {
			order = 4,
			type = 'toggle',
			name = L["Show Datatext Icon"],
			get = function(info)
				return E.db[mPlugin].SystemMenu.showicon
			end,
			set = function(info, value)
				E.db[mPlugin].SystemMenu.showicon = value
				DT:ForceUpdate_DataText("mGameMenu")
			end,
		},
		systemmmenutipinstance = {
			order = 5,
			type = 'toggle',
			name = L["Tooltip Instanceinfo"],
			desc = L["Shows Inctance Info and Mythic Plus key tone in tooltip."],
			get = function(info)
				return E.db[mPlugin].InstancInfoToolTip
			end,
			set = function(info, value)
				E.db[mPlugin].InstancInfoToolTip = value
			end,
		},
		systemmmenuinstancename = {
			order = 8,
			type = 'toggle',
			name = L["Text to Instance Name"],
			desc = L["Display the instance name instead of System Menu."],
			get = function(info)
				return E.db[mPlugin].InstancInfoName
			end,
			set = function(info, value)
				E.db[mPlugin].InstancInfoName = value
			end,
		},
	}
end
mInsert(ns.Config, OptionsSystemMenu)